#include "bsp.h"
#include "tty.h"

/* Port mappings:

   P0	D0-D7
   P1	D8-D15

   P2	A0-A7
   P3	A8-A15
   P4	A16-A23

   P5	I/O Signals

*/

extern void dllexit();

static const word patterns[] = {
  0x0000,
  0xffff,
  0xaaaa,
  0x5555,

  0x0000,
  0x0001,
  0x0002,
  0x0004,
  0x0008,
  0x0010,
  0x0020,
  0x0040,
  0x0080,
  0x0100,
  0x0200,
  0x0400,
  0x0800,
  0x1000,
  0x2000,
  0x4000,
  0x8000,

  0xffff,
  0xfffe,
  0xfffd,
  0xfffb,
  0xfff7,
  0xffef,
  0xffdf,
  0xffbf,
  0xf7ff,
  0xfeff,
  0xfdff,
  0xfbff,
  0xf7ff,
  0xefff,
  0xdfff,
  0xbfff,
  0x7fff
};
#define NPAT (sizeof(patterns)/sizeof(patterns[0]))

main()
{
  unsigned int i, j, t;
  unsigned char new_pd9;

  p10.b = 0x33;

  /* P0 through P3 pullups */
  pur0.b = 0xff;
  /* P4 through P5 pullups */
  pur1.b = 0x0f;

  pd0.b = 0x00;
  pd1.b = 0x00;

  pd2.b = 0xff;
  pd3.b = 0xff;
  pd4.b = 0xff;

  pd5.b = 0xff; /* HLD, RDY are input */

  new_pd9 = pd9.b | 0x0f;
  prcr.b = 0x04;
  pd9.b = new_pd9;

  p0.b = p1.b = p2.b = p3.b = p4.b = p5.b = 0;
#if 0
  while (!tty_ready ())
    {
      for (i=0; i<0xff; i++)
	{
	  register word v;

	  w = i & 63;

	  if (i & 64)
	    {
	      p0.b = 1 << w;
	      p1.b = 1 << (w-8);
	      p2.b = 1 << (w-16);
	      p3.b = 1 << (w-24);
	      p4.b = 1 << (w-32);
	      p5.b = 1 << (w-40);
	      p9.b = 1 << (w-48);
	    }
	  else
	    {
	      p0.b = ~(1 << w);
	      p1.b = ~(1 << (w-8));
	      p2.b = ~(1 << (w-16));
	      p3.b = ~(1 << (w-24));
	      p4.b = ~(1 << (w-32));
	      p5.b = ~(1 << (w-40));
	      p9.b = ~(1 << (w-48));
	    }

	}
      cprintf("%c\b", "|/-\\"[t++&3]);
    }
#endif

  //cprintf("\033[1;1H\033[2J");
  while (!tty_ready())
    {
      //cprintf("\033[1;1H");
      for (i=0; i<NPAT; i++)
	{
	  register word w;
	  w = patterns[i];
	  p2.b = w;
	  p3.b = w>>8;
	  j = p0.b | (p1.b<<8);
	  if (w == j)
	    cprintf("\033[32m%W -> %W\n", w, j);
	  else
	    cprintf("\033[31m%W -> %W\n", w, j);
	}
      cprintf("\033[0m\n");
      wait_ms(2000);
    }

  p0.b = p1.b = p2.b = p3.b = p4.b = p5.b = 0;
  p10.b = 0x00;
}
